#!/usr/local/bin/perl -- # -*- perl -*-

require "./codelib.pl";

use CGI;

$query = CGI::new();

$urlname = $query->param('url');
$urlname =~ s/%([\dA-Fa-f][\dA-Fa-f])/pack ("C", hex($1))/eg;

if ($urlname =~ m/^\s*$/) {
    print "Content-type: text/html\n\n";
    print "<HTML>\n<HEAD>\n";
    print "<TITLE>Empty URL</TITLE>\n";
    print "</HEAD>\n<BODY>\n";
    print "You did not type in a web address.  Please go back and enter one.";
    print $query->param();
    print " Please try again. $urlname </BODY>\n</HTML>";
    exit;
}

if ($urlname !~ m/:\//) {
    $urlname = "http://" . $urlname;
}


open(HTMLIN, "/usr/local/bin/perl ./bget $urlname |") || print "Content-type: text/plain\n\nCan't open lynx";


$urlbase = $urlname;
$urlbase =~ s#^((http|gopher|ftp)://[^/]+).*$#\1#i;

$urldir = $urlname;
$urldir =~  s#^((http|ftp|gopher)://.+/)[^/]+$#\1#i;


if ($query->param('conversion') eq "b52gb") {
    &initB52GB;
    $encoding = "gb2312";
} elsif ($query->param('conversion') eq "gb2b5") {
    &initGB2B5;
    $encoding = "big5";
} elsif ($query->param('conversion') eq "b52hz") {
    &initB52GB;
    $encoding = "gb2312";
} elsif ($query->param('conversion') eq "hz2b5") {
    &initGB2B5;
    $encoding = "big5";
} elsif ($query->param('conversion') eq "hz2gb") {
    &initHZ2GB;
    $encoding = "gb2312";
} elsif ($query->param('conversion') eq "gb2hz") {
    $encoding = "gb2312";
    # do nothing
} elsif ($query->param('conversion') eq "gb2utf8") {
    &initGB2UTF8;
    $encoding = "utf-8";
} elsif ($query->param('conversion') eq "hz2utf8") {
    &initGB2UTF8;
    $encoding = "utf-8";
} elsif ($query->param('conversion') eq "b52utf8") {
    &initB52UTF8;
    $encoding = "utf-8";
}

print "Content-type: text/", $query->param('texttype') , "; charset=$encoding\n\n";

$linesread = 0;
while ($urlline = <HTMLIN>) {
    $urltext .= $urlline;
    $linesread++;
}
close HTMLIN;


if ($linesread == 0) {
    print "<HTML>\n<HEAD>\n";
    print "<TITLE>URL Not Found</TITLE>\n</HEAD>\n";
    print "<BODY><H1>URL Not Found</H1>\n";
    print "The URL you requested either does not exist or is down at the ";
    print "moment.  If you are sure that the URL does exist and is up, please e-mail ";
    print "me with the URL at <A HREF=\"mailto:erik\@mandarintools.com\">erik\@mandarintools.com</A> and I will try to find the problem.<BR>\n";
    print "URL: $urlname<BR>\n";
    print "URL base: $urlbase <BR>\n";
    print "URL dir : $urldir <BR>\n";
    print "Text type: ", $query->param('texttype') ," <BR>\n";
    print "Conversion: ", $query->param('conversion')," <BR>\n";
    print "</BODY></HTML>\n";
    exit;
} 

# Try to set the base if not already set, so the relative links will work
$basetag = "\n<BASE HREF=\"$urldir\">\n";
if ($urltext !~ m/<base/i) {
    if ($urltext =~ s/(<head>)/$1/i) {
    } elsif ($urltext =~ s/(<\/title>)/$1$basetag/i) {
    } elsif ($urltext =~ s/(<html>)/$1$basetag/i) {
    } elsif ($urltext =~ s/(<body)/$basetag$1/i) {
    } 
}

# if a charset tag is included, replace the charset, otherwise add it in.
$metatag = "\n<META HTTP-EQUIV=\"content-type\" CONTENT=\"text/html; charset=$encoding\">\n";
if ($urltext =~ s/charset=([^\"]+)/charset=$encoding/i) {
} else {
    if ($urltext =~ s/(<head>)/$1$metatag/i) {
    } elsif ($urltext =~ s/(<\/title>)/$1$metatag/i) {
    } elsif ($urltext =~ s/(<html>)/$1$metatag/i) {
    } elsif ($urltext =~ s/(<body)/$metatag$1/i) {
    } 
}

print &sinofy($urltext);

				
sub sinofy {        
    my($urlline) = @_;
    my($outline) = "";		

    if ($query->param('conversion') eq "hz2b5" or $query->param('conversion') eq "hz2gb" or
	$query->param('conversion') eq "hz2utf8") {
	$urlline = &hz2gb($urlline);
    } elsif ($query->param('conversion') eq "gb2hz") {
	$urlline = &gb2hz($urlline);
    }
    $linelen = length($urlline);
    for ($i = 0; $i < $linelen; $i++) {
	$char = substr($urlline, $i, 1);
	if (unpack("C", $char) <= 127) {
	    $outline .= $char;
	} else {
	    $char = substr($urlline, $i, 2);
	    $i++;
	    $outline .= $convtab{$char};
	}
    }

    if ($query->param('conversion') eq "b52hz") {
	$outline = &gb2hz($outline);
    }
    $outline;
}


sub redourl {
    study($outline);
    if ($outline !~ m/(HREF|SRC|BACKGROUND)/i) {
	# do nothing
    } else {
	if ($outline =~ m!HREF\s?=\s?\"?/[/a-z0-9_.-]+(\"|>|\s)?!i) {
	    $outline =~ s!(HREF\s?=\s?\"?)(/[/a-z0-9_.-]+)(\"?)!\1$urlbase\2\3!gi;
	} elsif ($outline =~ m!HREF\s?=\s?\"?(\#|http:|gopher:|ftp:|telnet:|news:|mailto:)!i) {
	    # do nothing
	} elsif ($outline =~ m!HREF\s?=\s?\"?[/a-z0-9_.-]+\"?!i) { 
	    $outline =~ s!(HREF\s?=\s?\"?)([a-z0-9_.-]+)(\"?)!\1$urldir\2\3!gi;
	} 
	if ($outline =~ m!SRC\s?=\s?\"?(http:|gopher:|ftp:)!i) {
	    # do nothing
	} elsif ($outline =~ m!SRC\s?=\s?\"?/[/a-z0-9_.-]+\"?!i) {
	    $outline =~ s!(SRC\s?=\s?\"?)(/[/a-z0-9_.-]+)(\"?)!\1$urlbase\2\3!gi;
	} elsif ($outline =~ m!SRC\s?=\s?\"?[/a-z0-9_.-]+\"?!i) { # 
	    $outline =~ s!(SRC\s?=\s?\"?)([/a-z0-9_.-]+)(\"?)!\1$urldir\2\3!gi;
	}
	if ($outline =~ m!BACKGROUND\s?=\s?\"?(http:|gopher:|ftp:)!i) {
	    # do nothing
	} elsif ($outline =~ m!BACKGROUND\s?=\s?\"?/[/a-z0-9_.-]+\"?!i) {
	    $outline =~ s!(BACKGROUND\s?=\s?\"?)(/[/a-z0-9_.-]+)(\"?)!\1$urlbase\2\3!gi;
	} elsif ($outline =~ m!BACKGROUND\s?=\s?\"?[/a-z0-9_.-]+\"?!i) { # 
	    $outline =~ s!(BACKGROUND\s?=\s?\"?)([/a-z0-9_.-]+)(\"?)!\1$urldir\2\3!gi;
	}
    }
}


sub initB52GB {
    open(B2G, "g2bchar.tab") || print "Content-type: text/plain\n\nCan't open conversion table\n";
    while ($line = <B2G>) {
	if ($line =~ m/^#/) {
	    next;
	}
	chomp($line);
	$gbchar = substr($line, 0, 2);
	$linelen = length($line) - 2;
	$b5char = substr($line, 2, $linelen);
	for ($i = 0; $i < $linelen; $i += 2) { 
	    $convtab{substr($b5char, $i, 2)} = $gbchar;
	}
    }
}


sub initGB2B5 {
    open(G2B, "g2bchar.tab") || print "Content-type: text/plain\n\nCan't open conversion table\n";
    while ($gbline = <G2B>) {
	if ($gbline =~ m/^#/) {
	    next;
	}	
	chomp($gbline);
	$gbchar = substr($gbline, 0, 2);
	$linelen = length($gbline) - 2;
	$b5char = substr($gbline, 2, $linelen);
	$convtab{$gbchar} = substr($b5char, 0, 2);
    }
}


# initHZ2GB: The identity function.  Each GB character is matched with itself.

sub initHZ2GB {
    open(G2B, "g2bchar.tab") || print "Content-type: text/plain\n\nCan't open conversion table\n";
    while ($gbline = <G2B>) {
	if ($gbline =~ m/^#/) {
	    next;
	}	
	chomp($gbline);
	$gbchar = substr($gbline, 0, 2);
	$convtab{$gbchar} = $gbchar;
    }
}


sub initGB2UTF8 {
    open(G2U, "GB2312.TXT") || print "Content-type: text/plain\n\nCan't open GB2312.TXT";
    while ($gbline = <G2U>) {
	next if ($gbline =~ m/^\#/);
	chomp($gbline);
	($gbchar, $unichar, $rest) = split(/\t/, $gbline);
	$convtab{hex2gb($gbchar)} = hex2utf8($unichar);
    }
}

sub initB52UTF8 {
    open(B2U, "BIG5.TXT") || print "Content-type: text/plain\n\nCan't open BIG5.TXT";
    while ($b5line = <B2U>) {
	next if ($b5line =~ m/^\#/);
	chomp($b5line);
	($b5char, $unichar, $rest) = split(/\t/, $b5line);
	$convtab{hex2big5($b5char)} = hex2utf8($unichar);
    }
}
